<< problem 53 - Combinatoric selections | Lychrel numbers - problem 55 >> |

# Problem 54: Poker hands

(see projecteuler.net/problem=54)

In the card game poker, a hand consists of five cards and are ranked, from lowest to highest, in the following way:

High Card:Highest value card.

One Pair:Two cards of the same value.

Two Pairs:Two different pairs.

Three of a Kind:Three cards of the same value.

Straight:All cards are consecutive values.

Flush:All cards of the same suit.

Full House:Three of a kind and a pair.

Four of a Kind:Four cards of the same value.

Straight Flush:All cards are consecutive values of same suit.

Royal Flush:Ten, Jack, Queen, King, Ace, in same suit.

The cards are valued in the order: 2, 3, 4, 5, 6, 7, 8, 9, 10, Jack, Queen, King, Ace.

If two players have the same ranked hands then the rank made up of the highest value wins;

for example, a pair of eights beats a pair of fives (see example 1 below).

But if two ranks tie, for example, both players have a pair of queens, then highest cards in each hand are compared (see example 4 below);

if the highest cards tie then the next highest cards are compared, and so on.

Consider the following five hands dealt to two players:

HandPlayer 1Player 2Winner

15H 5C 6S 7S KD2C 3S 8S 8D TDPlayer 2

Pair of FivesPair of Eights

25D 8C 9S JS AC2C 5C 7D 8S QHPlayer 1

Highest card AceHighest card Queen

32D 9C AS AH AC3D 6D 7D TD QDPlayer 2

Three AcesFlush with Diamonds

44D 6S 9H QH QC3D 6D 7H QD QSPlayer 1

Pair of QueensPair of Queens

Highest card NineHighest card Seven

52H 2D 4C 4D 4S3C 3D 3S 9S 9DPlayer 1

Full HouseFull House

With Three FoursWith Three Threes

The file, poker.txt, contains one-thousand random hands dealt to two players.

Each line of the file contains ten cards (separated by a single space): the first five are Player 1's cards and the last five are Player 2's cards.

You can assume that all hands are valid (no invalid characters or repeated cards), each player's hand is in no specific order, and in each hand there is a clear winner.

How many hands does Player 1 win?

# My Algorithm

`cardMask`

converts a string to a 64 bit integer bitmask:

There are 13 different poker cards (2, 3, 4, 5, 6, 7, 8, 9, 10, Jack, Queen, King, Ace) of 4 different suits (Diamonds, Hearts, Spades and Clubs).

Each of those 13 * 4 = 52 cards is assigned to a certain bit position:

Card:`00000000`

`0000AKQJ`

`T9876543`

`2AKQJT98`

`765432AK`

`QJT98765`

`432AKQJT`

`98765432`

Suit:`00000000`

`0000CCCC`

`CCCCCCCC`

`CSSSSSSS`

`SSSSSSHH`

`HHHHHHHH`

`HHHDDDDD`

`DDDDDDDD`

Each binary representation of a valid Poker hand has exactly 5 bits set.

If a player holds Hearts 2, Diamonds 7, Diamonds King, Clubs King and Clubs Ace, then the binary representation is:

`00000000`

`00001100`

`00000000`

`00000000`

`00000000`

`00000000`

`00101000`

`00100000`

`rank`

assigns a value to a hand of five Poker cards: a hand with a lower value beats all hands with a higher value.

There are a few steps I always do before actually evaluating a hand:

1. figure out whether we have a straight (5 consecutive bits are set or A2345)

2. count how often each card is present, ignoring its suit

3. do all cards share the same suit ? (a flush)

Then a number is assigned to each hand:

Royal Flush1

Straight Flush2..10

Four of a Kind10000000000 + 100*four + 1*single

Full House20000000000 + 100*three + 1*two

Flush30000000000 + 100000000*highest + 100000*second + 10000*third + 100*fourth + 1*worst

Straight40000000000 + 1..10

Three of a Kind50000000000 + 10000*three + 100*bestSingle + 1*worstSingle

Two Pairs60000000000 + 10000*bestPair + 100*wordPair + 1*single

One Pair70000000000 + 1000000*pair + 10000*bestSingle + 100*middleSingle + 1*worstSingle

High Card80000000000 + 100000000*highest + 100000*second + 10000*third + 100*fourth + 1*worst

My number system isn't very efficient but quite easy to debug.

There are actually only 2598960 different hands \binom{52}{5} = frac{52!}{(52-5)!5!}.

## Alternative Approaches

There is an endless number of Poker hand evaluators available on the internet.

And I am pretty sure you will find an endless number of ways to evaluate a Poker hand.

## Note

My program doesn't check its input. It must follow the syntax defined by the problem statement (which is a widely accepted Poker hand notation).

# My code

… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, as well as the input data, too.

The code contains `#ifdef`

s to switch between the original problem and the Hackerrank version.

Enable `#ifdef ORIGINAL`

to produce the result for the original problem (default setting for most problems).

#include <string>
#include <iostream>
const unsigned long long Card2 = 1ULL << 0;
const unsigned long long Card3 = 1ULL << 1;
const unsigned long long Card4 = 1ULL << 2;
const unsigned long long Card5 = 1ULL << 3;
const unsigned long long Card6 = 1ULL << 4;
const unsigned long long Card7 = 1ULL << 5;
const unsigned long long Card8 = 1ULL << 6;
const unsigned long long Card9 = 1ULL << 7;
const unsigned long long CardT = 1ULL << 8;
const unsigned long long CardJ = 1ULL << 9;
const unsigned long long CardQ = 1ULL << 10;
const unsigned long long CardK = 1ULL << 11;
const unsigned long long CardA = 1ULL << 12;
// convert a card to a 52-bitmask

unsigned long long cardMask(const std::string& card) // card format is 5H for 5 of hearts
{
// bit mask structure:
// bits from 0 to 12 are 23456789TJQKA of diamonds
// bits from 13 to 25 are 23456789TJQKA of hearts
// bits from 26 to 38 are 23456789TJQKA of spades
// bits from 39 to 51 are 23456789TJQKA of clubs
// bits 52+ are zero
unsigned long long result = 0;
switch (card[0])
{
case '2': result = Card2; break;
case '3': result = Card3; break;
case '4': result = Card4; break;
case '5': result = Card5; break;
case '6': result = Card6; break;
case '7': result = Card7; break;
case '8': result = Card8; break;
case '9': result = Card9; break;
case 'T': result = CardT; break;
case 'J': result = CardJ; break;
case 'Q': result = CardQ; break;
case 'K': result = CardK; break;
case 'A': result = CardA; break;
default: break;
}
switch (card[1])
{
case 'D': break;
case 'H': result <<= 13; break;
case 'S': result <<= 26; break;
case 'C': result <<= 39; break;
default: break;
}
return result;
}
// each hand with a certain rank beats all hands with a higher rank

unsigned long long rank(unsigned long long hand)
{
// set the lowest 13 bits (= 13 cards of a suit)
const auto Suit = (1LL << 13) - 1;
// ignore color (convert all cards to diamonds)
auto colorless = (hand | (hand >> 13) | (hand >> 26) | (hand >> 39)) & Suit;
// greater zero if straight (better straights get higher value)
unsigned int straight = 0;
if (colorless == (CardT | CardJ | CardQ | CardK | CardA)) straight = 1;
if (colorless == (Card9 | CardT | CardJ | CardQ | CardK)) straight = 2;
if (colorless == (Card8 | Card9 | CardT | CardJ | CardQ)) straight = 3;
if (colorless == (Card7 | Card8 | Card9 | CardT | CardJ)) straight = 4;
if (colorless == (Card6 | Card7 | Card8 | Card9 | CardT)) straight = 5;
if (colorless == (Card5 | Card6 | Card7 | Card8 | Card9)) straight = 6;
if (colorless == (Card4 | Card5 | Card6 | Card7 | Card8)) straight = 7;
if (colorless == (Card3 | Card4 | Card5 | Card6 | Card7)) straight = 8;
if (colorless == (Card2 | Card3 | Card4 | Card5 | Card6)) straight = 9;
if (colorless == (CardA | Card2 | Card3 | Card4 | Card5)) straight = 10;
// pairs, triple, fours
unsigned int count[13] = { 0,0,0,0,0,0,0,0,0,0,0,0,0 };
for (unsigned int i = 0; i < 13; i++)
{
if (hand & (1ULL << i))
count[i]++;
if (hand & (1ULL << (i+13)))
count[i]++;
if (hand & (1ULL << (i+26)))
count[i]++;
if (hand & (1ULL << (i+39)))
count[i]++;
}
// true, if all cards share the same colors
bool isFlush = (hand == colorless) ||
(hand == (colorless << 13)) ||
(hand == (colorless << 26)) ||
(hand == (colorless << 39));
// allocate 10000000000 IDs per category (flush, straight, pairs, etc.)
const unsigned long long GroupSize = 10000000000ULL; // burn up to two digits per card
unsigned long long result = 0;
// royal flush and straight flush
if (isFlush && straight > 0)
return result + straight;
result += GroupSize;
// four-of-a-kind
for (unsigned int i = 0; i < 13; i++)
if (count[i] == 4)
for (unsigned int j = 0; j < 13; j++)
if (count[j] == 1)
return result + (13 - i) * 100 + (13 - j);
result += GroupSize;
// full-house
for (unsigned int i = 0; i < 13; i++)
if (count[i] == 3)
for (unsigned int j = 0; j < 13; j++)
if (count[j] == 2)
return result + (13 - i) * 100 + (13 - j);
result += GroupSize;
// flush
if (isFlush)
{
unsigned long long value = 0;
for (int i = 12; i >= 0; i--)
if (count[i] == 1)
{
value *= 100;
value += 13 - i;
}
return result + value;
}
result += GroupSize;
// straight
if (straight > 0)
return result + straight;
result += GroupSize;
// three
for (unsigned int i = 0; i < 13; i++)
if (count[i] == 3)
{
unsigned long long value = 13 - i;
for (int j = 12; j >= 0; j--)
if (count[j] == 1)
{
value *= 100;
value += 13 - j;
}
return result + value;
}
result += GroupSize;
// one or two pairs
unsigned int numPairs = 0;
for (unsigned int i = 0; i < 13; i++)
if (count[i] == 2)
numPairs++;
if (numPairs > 0)
{
unsigned long long value = 0;
// pairs
for (int i = 12; i >= 0; i--)
if (count[i] == 2)
{
value *= 100;
value += 13 - i;
}
// single card(s)
for (int i = 12; i >= 0; i--)
if (count[i] == 1)
{
value *= 100;
value += 13 - i;
}
if (numPairs == 1)
result += GroupSize;
return result + value;
}
result += 2 * GroupSize; // one and two pairs
// high card
unsigned long long value = 0;
for (int i = 12; i >= 0; i--)
if (count[i] == 1)
{
value *= 100;
value += 13 - i;
}
return result + value;
}
int main()
{
unsigned int tests = 1000;
//#define ORIGINAL

#ifdef ORIGINAL
unsigned int won1 = 0;
unsigned int won2 = 0;
#else
std::cin >> tests;
#endif
while (tests--)
{
std::string cards1[5], cards2[5];
std::cin >> cards1[0] >> cards1[1] >> cards1[2] >> cards1[3] >> cards1[4];
std::cin >> cards2[0] >> cards2[1] >> cards2[2] >> cards2[3] >> cards2[4];
// convert to bitmask and merge with logical OR
auto player1 = cardMask(cards1[0]) | cardMask(cards1[1]) | cardMask(cards1[2]) |
cardMask(cards1[3]) | cardMask(cards1[4]);
auto player2 = cardMask(cards2[0]) | cardMask(cards2[1]) | cardMask(cards2[2]) |
cardMask(cards2[3]) | cardMask(cards2[4]);
// lower rank wins
auto rank1 = rank(player1);
auto rank2 = rank(player2);
#ifdef ORIGINAL
if (rank1 < rank2)
won1++;
if (rank1 > rank2)
won2++;
#else
std::cout << "Player " << (rank1 < rank2 ? "1" : "2") << std::endl;
#endif
}
#ifdef ORIGINAL
std::cout << won1 << std::endl;
//std::cout << won2 << std::endl;
#endif
return 0;
}

This solution contains 26 empty lines, 28 comments and 10 preprocessor commands.

# Interactive test

You can submit your own input to my program and it will be instantly processed at my server:

This live test is based on the Hackerrank problem.

This is equivalent to`echo "1 5H 5C 6S 7S KD 2C 3S 8S 8D TD" | ./54`

Output:

*(this interactive test is still under development, computations will be aborted after one second)*

# Benchmark

The correct solution to the original Project Euler problem was found in less than 0.01 seconds on a Intel® Core™ i7-2600K CPU @ 3.40GHz.

(compiled for x86_64 / Linux, GCC flags: `-O3 -march=native -fno-exceptions -fno-rtti -std=c++11 -DORIGINAL`

)

See here for a comparison of all solutions.

**Note:** interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without `-DORIGINAL`

.

# Changelog

February 28, 2017 submitted solution

April 21, 2017 added comments

# Hackerrank

see https://www.hackerrank.com/contests/projecteuler/challenges/euler054

My code solves **7** out of **7** test cases (score: **100%**)

# Difficulty

Project Euler ranks this problem at **10%** (out of 100%).

Hackerrank describes this problem as **easy**.

*Note:*

Hackerrank has strict execution time limits (typically 2 seconds for C++ code) and often a much wider input range than the original problem.

In my opinion, Hackerrank's modified problems are usually a lot harder to solve. As a rule thumb: brute-force is rarely an option.

# Links

projecteuler.net/thread=54 - **the** best forum on the subject (*note:* you have to submit the correct solution first)

Code in various languages:

Python: www.mathblog.dk/project-euler-54-poker-hands/ (written by Kristian Edlund)

Java: github.com/nayuki/Project-Euler-solutions/blob/master/java/p054.java (written by Nayuki)

Go: github.com/frrad/project-euler/blob/master/golang/Problem054.go (written by Frederick Robinson)

Javascript: github.com/dsernst/ProjectEuler/blob/master/54 Poker hands.js (written by David Ernst)

Scala: github.com/samskivert/euler-scala/blob/master/Euler054.scala (written by Michael Bayne)

# Heatmap

green problems solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too.

yellow problems score less than 100% at Hackerrank (but still solve the original problem).

gray problems are already solved but I haven't published my solution yet.

blue problems are solved and there wasn't a Hackerrank version of it at the time I solved it or I didn't care about it because it differed too much.

red problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte.

*Please click on a problem's number to open my solution to that problem:*

1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |

26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |

51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |

76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |

101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |

126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |

151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |

176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |

201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |

226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |

251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |

276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |

301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |

326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |

351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |

376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |

401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |

426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |

451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |

476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |

501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |

526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |

I scored 12,983 points (out of 15100 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.

Look at my progress and performance pages to get more details.

My username at Project Euler is

**stephanbrumme**while it's stbrumme at Hackerrank.

# Copyright

I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.

All of my solutions can be used for any purpose and I am in no way liable for any damages caused.

You can even remove my name and claim it's yours. But then you shall burn in hell.

The problems and most of the problems' images were created by Project Euler. Thanks for all their endless effort.

<< problem 53 - Combinatoric selections | Lychrel numbers - problem 55 >> |